Index: src/includes/classes/Smarty/sysplugins/smarty_internal_templatecompilerbase.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_templatecompilerbase.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_templatecompilerbase.php	(revision )
@@ -480,16 +654,18 @@
                             foreach ($args as $mixed) {
                                 $new_args = array_merge($new_args, $mixed);
                             }
-                            $function = $this->default_handler_plugins[$plugin_type][$tag][0];
+                            $function = $this->default_handler_plugins[ $plugin_type ][ $tag ][ 0 ];
                             if (!is_array($function)) {
                                 return $function($new_args, $this);
-                            } elseif (is_object($function[0])) {
+                            } elseif (is_object($function[ 0 ])) {
-                                return $this->default_handler_plugins[$plugin_type][$tag][0][0]->$function[1]($new_args, $this);
+                                return $this->default_handler_plugins[ $plugin_type ][ $tag ][ 0 ][ 0 ]->$function[ 1 ]($new_args,
+                                                                                                                        $this);
                             } else {
                                 return call_user_func_array($function, array($new_args, $this));
                             }
                         } else {
-                            return $this->callTagCompiler('private_registered_' . $plugin_type, $args, $parameter, $tag);
+                            return $this->callTagCompiler('private_registered_' . $plugin_type, $args, $parameter,
+                                                          $tag);
                         }
                     }
                 }
@@ -497,35 +673,52 @@
                 // compile closing tag of block function
                 $base_tag = substr($tag, 0, - 5);
                 // check if closing tag is a registered object
-                if (isset($this->smarty->registered_objects[$base_tag]) && isset($parameter['object_method'])) {
+                if (isset($this->smarty->registered_objects[ $base_tag ]) && isset($parameter[ 'object_method' ])) {
-                    $method = $parameter['object_method'];
+                    $method = $parameter[ 'object_method' ];
-                    if (in_array($method, $this->smarty->registered_objects[$base_tag][3])) {
+                    if (in_array($method, $this->smarty->registered_objects[ $base_tag ][ 3 ])) {
-                        return $this->callTagCompiler('private_object_block_function', $args, $parameter, $tag, $method);
+                        return $this->callTagCompiler('private_object_block_function', $args, $parameter, $tag,
+                                                      $method);
                     } else {
                         // throw exception
-                        $this->trigger_template_error('not allowed closing tag method "' . $method . '" in registered object "' . $base_tag . '"', $this->lex->taglineno);
+                        $this->trigger_template_error('not allowed closing tag method "' . $method .
+                                                      '" in registered object "' . $base_tag . '"', null, true);
                     }
                 }
                 // registered block tag ?
-                if (isset($this->smarty->registered_plugins[Smarty::PLUGIN_BLOCK][$base_tag]) || isset($this->default_handler_plugins[Smarty::PLUGIN_BLOCK][$base_tag])) {
+                if (isset($this->smarty->registered_plugins[ Smarty::PLUGIN_BLOCK ][ $base_tag ]) ||
+                    isset($this->default_handler_plugins[ Smarty::PLUGIN_BLOCK ][ $base_tag ])
+                ) {
                     return $this->callTagCompiler('private_registered_block', $args, $parameter, $tag);
                 }
+                // registered function tag ?
+                if (isset($this->smarty->registered_plugins[ Smarty::PLUGIN_FUNCTION ][ $tag ])) {
+                    return $this->callTagCompiler('private_registered_function', $args, $parameter, $tag);
+                }
                 // block plugin?
                 if ($function = $this->getPlugin($base_tag, Smarty::PLUGIN_BLOCK)) {
                     return $this->callTagCompiler('private_block_plugin', $args, $parameter, $tag, $function);
                 }
+                // function plugin?
+                if ($function = $this->getPlugin($tag, Smarty::PLUGIN_FUNCTION)) {
+                    if (!isset($this->smarty->security_policy) ||
+                        $this->smarty->security_policy->isTrustedTag($tag, $this)
+                    ) {
+                        return $this->callTagCompiler('private_function_plugin', $args, $parameter, $tag, $function);
+                    }
+                }
                 // registered compiler plugin ?
-                if (isset($this->smarty->registered_plugins[Smarty::PLUGIN_COMPILER][$tag])) {
+                if (isset($this->smarty->registered_plugins[ Smarty::PLUGIN_COMPILER ][ $tag ])) {
                     // if compiler function plugin call it now
                     $args = array();
-                    if (!$this->smarty->registered_plugins[Smarty::PLUGIN_COMPILER][$tag][1]) {
+                    if (!$this->smarty->registered_plugins[ Smarty::PLUGIN_COMPILER ][ $tag ][ 1 ]) {
                         $this->tag_nocache = true;
                     }
-                    $function = $this->smarty->registered_plugins[Smarty::PLUGIN_COMPILER][$tag][0];
+                    $function = $this->smarty->registered_plugins[ Smarty::PLUGIN_COMPILER ][ $tag ][ 0 ];
                     if (!is_array($function)) {
                         return $function($args, $this);
-                    } elseif (is_object($function[0])) {
+                    } elseif (is_object($function[ 0 ])) {
-                        return $this->smarty->registered_plugins[Smarty::PLUGIN_COMPILER][$tag][0][0]->$function[1]($args, $this);
+                        return $this->smarty->registered_plugins[ Smarty::PLUGIN_COMPILER ][ $tag ][ 0 ][ 0 ]->$function[ 1 ]($args,
+                                                                                                                              $this);
                     } else {
                         return call_user_func_array($function, array($args, $this));
                     }
@@ -544,15 +737,110 @@
                     throw new SmartyException("Plugin \"{$tag}\" not callable");
                 }
             }
-            $this->trigger_template_error("unknown tag \"" . $tag . "\"", $this->lex->taglineno);
+            $this->trigger_template_error("unknown tag \"" . $tag . "\"", null, true);
         }
     }
 
     /**
+     * compile variable
+     *
+     * @param string $variable
+     *
+     * @return string
+     */
+    public function compileVariable($variable)
+    {
+        if (strpos($variable, '(') == 0) {
+            // not a variable variable
+            $var = trim($variable, '\'');
+            $this->tag_nocache = $this->tag_nocache |
+                $this->template->ext->getTemplateVars->_getVariable($this->template, $var, null, true, false)->nocache;
+            // todo $this->template->compiled->properties['variables'][$var] = $this->tag_nocache | $this->nocache;
+        }
+        return '$_smarty_tpl->tpl_vars[' . $variable . ']->value';
+    }
+
+    /**
+     * compile config variable
+     *
+     * @param string $variable
+     *
+     * @return string
+     */
+    public function compileConfigVariable($variable)
+    {
+        // return '$_smarty_tpl->config_vars[' . $variable . ']';
+        return '$_smarty_tpl->smarty->ext->configLoad->_getConfigVariable($_smarty_tpl, ' . $variable . ')';
+    }
+
+    /**
+     * This method is called from parser to process a text content section
+     * - remove text from inheritance child templates as they may generate output
+     * - strip text if strip is enabled
+     *
+     * @param string $text
+     *
+     * @return null|\Smarty_Internal_ParseTree_Text
+     */
+    public function processText($text)
+    {
+        if ((string) $text != '') {
+            $store = array();
+            $_store = 0;
+            $_offset = 0;
+            if ($this->parser->strip) {
+                if (strpos($text, '<') !== false) {
+                    // capture html elements not to be messed with
+                    $_offset = 0;
+                    if (preg_match_all('#(<script[^>]*>.*?</script[^>]*>)|(<textarea[^>]*>.*?</textarea[^>]*>)|(<pre[^>]*>.*?</pre[^>]*>)#is',
+                                       $text, $matches, PREG_OFFSET_CAPTURE | PREG_SET_ORDER)) {
+                        foreach ($matches as $match) {
+                            $store[] = $match[ 0 ][ 0 ];
+                            $_length = strlen($match[ 0 ][ 0 ]);
+                            $replace = '@!@SMARTY:' . $_store . ':SMARTY@!@';
+                            $text = substr_replace($text, $replace, $match[ 0 ][ 1 ] - $_offset, $_length);
+
+                            $_offset += $_length - strlen($replace);
+                            $_store ++;
+                        }
+                    }
+
+                    $expressions = array(// replace multiple spaces between tags by a single space
+                                         // can't remove them entirely, becaue that might break poorly implemented CSS display:inline-block elements
+                                         '#(:SMARTY@!@|>)\s+(?=@!@SMARTY:|<)#s'                                    => '\1 \2',
+                                         // remove spaces between attributes (but not in attribute values!)
+                                         '#(([a-z0-9]\s*=\s*("[^"]*?")|(\'[^\']*?\'))|<[a-z0-9_]+)\s+([a-z/>])#is' => '\1 \5',
+                                         '#^\s+<#Ss'                                                               => '<',
+                                         '#>\s+$#Ss'                                                               => '>',
+                                         $this->stripRegEx                                                         => '');
+
+                    $text = preg_replace(array_keys($expressions), array_values($expressions), $text);
+                    $_offset = 0;
+                    if (preg_match_all('#@!@SMARTY:([0-9]+):SMARTY@!@#is', $text, $matches,
+                                       PREG_OFFSET_CAPTURE | PREG_SET_ORDER)) {
+                        foreach ($matches as $match) {
+                            $_length = strlen($match[ 0 ][ 0 ]);
+                            $replace = $store[ $match[ 1 ][ 0 ] ];
+                            $text = substr_replace($text, $replace, $match[ 0 ][ 1 ] + $_offset, $_length);
+
+                            $_offset += strlen($replace) - $_length;
+                            $_store ++;
+                        }
+                    }
+                } else {
+                    $text = preg_replace($this->stripRegEx, '', $text);
+                }
+            }
+            return new Smarty_Internal_ParseTree_Text($text);
+        }
+        return null;
+    }
+
+    /**
      * lazy loads internal compile plugin for tag and calls the compile method
      * compile objects cached for reuse.
      * class name format:  Smarty_Internal_Compile_TagName
-     * plugin filename format: Smarty_Internal_Tagname.php
+     * plugin filename format: Smarty_Internal_TagName.php
      *
      * @param  string $tag    tag name
      * @param  array  $args   list of tag attributes
@@ -565,23 +853,23 @@
     public function callTagCompiler($tag, $args, $param1 = null, $param2 = null, $param3 = null)
     {
         // re-use object if already exists
-        if (isset(self::$_tag_objects[$tag])) {
-            // compile this tag
-            return self::$_tag_objects[$tag]->compile($args, $this, $param1, $param2, $param3);
-        }
+        if (!isset($this->_tag_objects[ $tag ])) {
-        // lazy load internal compiler plugin
+            // lazy load internal compiler plugin
-        $class_name = 'Smarty_Internal_Compile_' . $tag;
-        if ($this->smarty->loadPlugin($class_name)) {
-            // check if tag allowed by security
-            if (!isset($this->smarty->security_policy) || $this->smarty->security_policy->isTrustedTag($tag, $this)) {
-                // use plugin if found
-                self::$_tag_objects[$tag] = new $class_name;
-                // compile this tag
-                return self::$_tag_objects[$tag]->compile($args, $this, $param1, $param2, $param3);
+            $_tag = explode('_', $tag);
+            $_tag = array_map('ucfirst', $_tag);
+            $class_name = 'Smarty_Internal_Compile_' . implode('_', $_tag);
+            if (class_exists($class_name) &&
+                (!isset($this->smarty->security_policy) || $this->smarty->security_policy->isTrustedTag($tag, $this))
+            ) {
+                $this->_tag_objects[ $tag ] = new $class_name;
+            } else {
+                $this->_tag_objects[ $tag ] = false;
+                return false;
             }
         }
-        // no internal compile plugin for this tag
-        return false;
+        // compile this tag
+        return $this->_tag_objects[ $tag ] === false ? false :
+            $this->_tag_objects[ $tag ]->compile($args, $this, $param1, $param2, $param3);
     }
 
     /**
@@ -596,23 +884,29 @@
     {
         $function = null;
         if ($this->template->caching && ($this->nocache || $this->tag_nocache)) {
-            if (isset($this->template->required_plugins['nocache'][$plugin_name][$plugin_type])) {
-                $function = $this->template->required_plugins['nocache'][$plugin_name][$plugin_type]['function'];
-            } elseif (isset($this->template->required_plugins['compiled'][$plugin_name][$plugin_type])) {
-                $this->template->required_plugins['nocache'][$plugin_name][$plugin_type] = $this->template->required_plugins['compiled'][$plugin_name][$plugin_type];
-                $function = $this->template->required_plugins['nocache'][$plugin_name][$plugin_type]['function'];
+            if (isset($this->parent_compiler->template->compiled->required_plugins[ 'nocache' ][ $plugin_name ][ $plugin_type ])) {
+                $function =
+                    $this->parent_compiler->template->compiled->required_plugins[ 'nocache' ][ $plugin_name ][ $plugin_type ][ 'function' ];
+            } elseif (isset($this->parent_compiler->template->compiled->required_plugins[ 'compiled' ][ $plugin_name ][ $plugin_type ])) {
+                $this->parent_compiler->template->compiled->required_plugins[ 'nocache' ][ $plugin_name ][ $plugin_type ] =
+                    $this->parent_compiler->template->compiled->required_plugins[ 'compiled' ][ $plugin_name ][ $plugin_type ];
+                $function =
+                    $this->parent_compiler->template->compiled->required_plugins[ 'nocache' ][ $plugin_name ][ $plugin_type ][ 'function' ];
             }
         } else {
-            if (isset($this->template->required_plugins['compiled'][$plugin_name][$plugin_type])) {
-                $function = $this->template->required_plugins['compiled'][$plugin_name][$plugin_type]['function'];
-            } elseif (isset($this->template->required_plugins['nocache'][$plugin_name][$plugin_type])) {
-                $this->template->required_plugins['compiled'][$plugin_name][$plugin_type] = $this->template->required_plugins['nocache'][$plugin_name][$plugin_type];
-                $function = $this->template->required_plugins['compiled'][$plugin_name][$plugin_type]['function'];
+            if (isset($this->parent_compiler->template->compiled->required_plugins[ 'compiled' ][ $plugin_name ][ $plugin_type ])) {
+                $function =
+                    $this->parent_compiler->template->compiled->required_plugins[ 'compiled' ][ $plugin_name ][ $plugin_type ][ 'function' ];
+            } elseif (isset($this->parent_compiler->template->compiled->required_plugins[ 'nocache' ][ $plugin_name ][ $plugin_type ])) {
+                $this->parent_compiler->template->compiled->required_plugins[ 'compiled' ][ $plugin_name ][ $plugin_type ] =
+                    $this->parent_compiler->template->compiled->required_plugins[ 'nocache' ][ $plugin_name ][ $plugin_type ];
+                $function =
+                    $this->parent_compiler->template->compiled->required_plugins[ 'compiled' ][ $plugin_name ][ $plugin_type ][ 'function' ];
             }
         }
         if (isset($function)) {
             if ($plugin_type == 'modifier') {
-                $this->modifier_plugins[$plugin_name] = true;
+                $this->modifier_plugins[ $plugin_name ] = true;
             }
 
             return $function;
@@ -623,14 +917,18 @@
 
         if (is_string($file)) {
             if ($this->template->caching && ($this->nocache || $this->tag_nocache)) {
-                $this->template->required_plugins['nocache'][$plugin_name][$plugin_type]['file'] = $file;
-                $this->template->required_plugins['nocache'][$plugin_name][$plugin_type]['function'] = $function;
+                $this->parent_compiler->template->compiled->required_plugins[ 'nocache' ][ $plugin_name ][ $plugin_type ][ 'file' ] =
+                    $file;
+                $this->parent_compiler->template->compiled->required_plugins[ 'nocache' ][ $plugin_name ][ $plugin_type ][ 'function' ] =
+                    $function;
             } else {
-                $this->template->required_plugins['compiled'][$plugin_name][$plugin_type]['file'] = $file;
-                $this->template->required_plugins['compiled'][$plugin_name][$plugin_type]['function'] = $function;
+                $this->parent_compiler->template->compiled->required_plugins[ 'compiled' ][ $plugin_name ][ $plugin_type ][ 'file' ] =
+                    $file;
+                $this->parent_compiler->template->compiled->required_plugins[ 'compiled' ][ $plugin_name ][ $plugin_type ][ 'function' ] =
+                    $function;
             }
             if ($plugin_type == 'modifier') {
-                $this->modifier_plugins[$plugin_name] = true;
+                $this->modifier_plugins[ $plugin_name ] = true;
             }
 
             return $function;
@@ -656,30 +954,35 @@
         $callback = null;
         $script = null;
         $cacheable = true;
-        $result = call_user_func_array(
-            $this->smarty->default_plugin_handler_func, array($tag, $plugin_type, $this->template, &$callback, &$script, &$cacheable)
-        );
+        $result = call_user_func_array($this->smarty->default_plugin_handler_func,
+                                       array($tag, $plugin_type, $this->template, &$callback, &$script, &$cacheable));
         if ($result) {
             $this->tag_nocache = $this->tag_nocache || !$cacheable;
             if ($script !== null) {
                 if (is_file($script)) {
                     if ($this->template->caching && ($this->nocache || $this->tag_nocache)) {
-                        $this->template->required_plugins['nocache'][$tag][$plugin_type]['file'] = $script;
-                        $this->template->required_plugins['nocache'][$tag][$plugin_type]['function'] = $callback;
+                        $this->parent_compiler->template->compiled->required_plugins[ 'nocache' ][ $tag ][ $plugin_type ][ 'file' ] =
+                            $script;
+                        $this->parent_compiler->template->compiled->required_plugins[ 'nocache' ][ $tag ][ $plugin_type ][ 'function' ] =
+                            $callback;
                     } else {
-                        $this->template->required_plugins['compiled'][$tag][$plugin_type]['file'] = $script;
-                        $this->template->required_plugins['compiled'][$tag][$plugin_type]['function'] = $callback;
+                        $this->parent_compiler->template->compiled->required_plugins[ 'compiled' ][ $tag ][ $plugin_type ][ 'file' ] =
+                            $script;
+                        $this->parent_compiler->template->compiled->required_plugins[ 'compiled' ][ $tag ][ $plugin_type ][ 'function' ] =
+                            $callback;
                     }
-                    include_once $script;
+                    require_once $script;
                 } else {
                     $this->trigger_template_error("Default plugin handler: Returned script file \"{$script}\" for \"{$tag}\" not found");
                 }
             }
-            if (!is_string($callback) && !(is_array($callback) && is_string($callback[0]) && is_string($callback[1]))) {
+            if (!is_string($callback) &&
+                !(is_array($callback) && is_string($callback[ 0 ]) && is_string($callback[ 1 ]))
+            ) {
                 $this->trigger_template_error("Default plugin handler: Returned callback for \"{$tag}\" must be a static function name or array of class and function name");
             }
             if (is_callable($callback)) {
-                $this->default_handler_plugins[$plugin_type][$tag] = array($callback, true, array());
+                $this->default_handler_plugins[ $plugin_type ][ $tag ] = array($callback, true, array());
 
                 return true;
             } else {
@@ -691,6 +994,25 @@
     }
 
     /**
+     * Append code segments and remove unneeded ?> <?php transitions
+     *
+     * @param string $left
+     * @param string $right
+     *
+     * @return string
+     */
+    public function appendCode($left, $right)
+    {
+        if (preg_match('/\s*\?>\s*$/', $left) && preg_match('/^\s*<\?php\s+/', $right)) {
+            $left = preg_replace('/\s*\?>\s*$/', "\n", $left);
+            $left .= preg_replace('/^\s*<\?php\s+/', '', $right);
+        } else {
+            $left .= $right;
+        }
+        return $left;
+    }
+
+    /**
      * Inject inline code for nocache template sections
      * This method gets the content of each template element from the parser.
      * If the content is compiled code and it should be not cached the code is injected
@@ -706,17 +1028,19 @@
         // If the template is not evaluated and we have a nocache section and or a nocache tag
         if ($is_code && !empty($content)) {
             // generate replacement code
-            if ((!($this->template->source->recompiled) || $this->forceNocache) && $this->template->caching && !$this->suppressNocacheProcessing &&
-                ($this->nocache || $this->tag_nocache)
+            if ((!($this->template->source->handler->recompiled) || $this->forceNocache) && $this->template->caching &&
+                !$this->suppressNocacheProcessing && ($this->nocache || $this->tag_nocache)
             ) {
-                $this->template->has_nocache_code = true;
+                $this->template->compiled->has_nocache_code = true;
                 $_output = addcslashes($content, '\'\\');
                 $_output = str_replace("^#^", "'", $_output);
-                $_output = "<?php echo '/*%%SmartyNocache:{$this->nocache_hash}%%*/" . $_output . "/*/%%SmartyNocache:{$this->nocache_hash}%%*/';?>\n";
+                $_output = "<?php echo '/*%%SmartyNocache:{$this->nocache_hash}%%*/" . $_output .
+                    "/*/%%SmartyNocache:{$this->nocache_hash}%%*/';?>\n";
                 // make sure we include modifier plugins for nocache code
                 foreach ($this->modifier_plugins as $plugin_name => $dummy) {
-                    if (isset($this->template->required_plugins['compiled'][$plugin_name]['modifier'])) {
-                        $this->template->required_plugins['nocache'][$plugin_name]['modifier'] = $this->template->required_plugins['compiled'][$plugin_name]['modifier'];
+                    if (isset($this->parent_compiler->template->compiled->required_plugins[ 'compiled' ][ $plugin_name ][ 'modifier' ])) {
+                        $this->parent_compiler->template->compiled->required_plugins[ 'nocache' ][ $plugin_name ][ 'modifier' ] =
+                            $this->parent_compiler->template->compiled->required_plugins[ 'compiled' ][ $plugin_name ][ 'modifier' ];
                     }
                 }
             } else {
@@ -733,44 +1057,46 @@
     }
 
     /**
-     *  push current file and line offset on stack for tracing {block} source lines
+     * Get Id
      *
-     * @param string      $file  new filename
-     * @param string      $uid   uid of file
-     * @param int         $line  line offset to source
-     * @param bool $debug false debug end_compile shall not be called
+     * @param string $input
+     *
+     * @return bool|string
      */
-    public function pushTrace($file, $uid, $line, $debug = true)
+    public function getId($input)
     {
-        if ($this->smarty->debugging && $debug) {
-            Smarty_Internal_Debug::end_compile($this->template);
+        if (preg_match('~^[\'"]*([0-9]*[a-zA-Z_]\w*)[\'"]*$~', $input, $match)) {
+            return $match[ 1 ];
         }
-        array_push($this->trace_stack, array($this->smarty->_current_file, $this->trace_filepath, $this->trace_uid, $this->trace_line_offset));
-        $this->trace_filepath = $this->smarty->_current_file = $file;
-        $this->trace_uid = $uid;
-        $this->trace_line_offset = $line;
-        if ($this->smarty->debugging) {
-            Smarty_Internal_Debug::start_compile($this->template);
+        return false;
-        }
+    }
-    }
 
     /**
-     *  restore file and line offset
-
+     * Get variable name from string
+     *
+     * @param string $input
+     *
+     * @return bool|string
      */
-    public function popTrace()
+    public function getVariableName($input)
     {
-        if ($this->smarty->debugging) {
-            Smarty_Internal_Debug::end_compile($this->template);
+        if (preg_match('~^[$]_smarty_tpl->tpl_vars\[[\'"]*([0-9]*[a-zA-Z_]\w*)[\'"]*\]->value$~', $input, $match)) {
+            return $match[ 1 ];
         }
-        $r = array_pop($this->trace_stack);
-        $this->smarty->_current_file = $r[0];
-        $this->trace_filepath = $r[1];
-        $this->trace_uid = $r[2];
-        $this->trace_line_offset = $r[3];
-        if ($this->smarty->debugging) {
-            Smarty_Internal_Debug::start_compile($this->template);
+        return false;
-        }
+    }
+
+    /**
+     * Generate nocache code string
+     *
+     * @param string $code PHP code
+     *
+     * @return string
+     */
+    public function makeNocacheCode($code)
+    {
+        return "echo '/*%%SmartyNocache:{$this->nocache_hash}%%*/<?php " .
+        str_replace("^#^", "'", addcslashes($code, '\'\\')) . "?>/*/%%SmartyNocache:{$this->nocache_hash}%%*/';\n";
     }
 
     /**
@@ -779,35 +1105,56 @@
      * In this case the parser is called to obtain information about expected tokens.
      * If parameter $args contains a string this is used as error message
      *
-     * @param  string $args individual error message or null
+     * @param  string   $args    individual error message or null
-     * @param  string $line line-number
+     * @param  string   $line    line-number
+     * @param null|bool $tagline if true the line number of last tag
      *
-     * @throws SmartyCompilerException when an unexpected token is found
+     * @throws \SmartyCompilerException when an unexpected token is found
      */
-    public function trigger_template_error($args = null, $line = null)
+    public function trigger_template_error($args = null, $line = null, $tagline = null)
     {
+        $lex = $this->parser->lex;
+        if ($tagline === true) {
+            // get line number of Tag
+            $line = $lex->taglineno;
+        } elseif (!isset($line)) {
-        // get template source line which has error
+            // get template source line which has error
-        if (!isset($line)) {
-            $line = $this->lex->line;
+            $line = $lex->line;
+        } else {
+            $line = (int) $line;
         }
+
+        if (in_array($this->template->source->type, array('eval', 'string'))) {
+            $templateName = $this->template->source->type . ':' . trim(preg_replace('![\t\r\n]+!', ' ',
+                                                                                    strlen($lex->data) > 40 ?
+                                                                                        substr($lex->data, 0, 40) .
+                                                                                        '...' : $lex->data));
+        } else {
+            $templateName = $this->template->source->type . ':' . $this->template->source->filepath;
+        }
+
         //        $line += $this->trace_line_offset;
-        $match = preg_split("/\n/", $this->lex->data);
-        $error_text = 'Syntax error in template "' . (empty($this->trace_filepath) ? $this->template->source->filepath : $this->trace_filepath) . '"  on line ' . ($line + $this->trace_line_offset) . ' "' . trim(preg_replace('![\t\r\n]+!', ' ', $match[$line - 1])) . '" ';
+        $match = preg_split("/\n/", $lex->data);
+        $error_text =
+            'Syntax error in template "' . (empty($this->trace_filepath) ? $templateName : $this->trace_filepath) .
+            '"  on line ' . ($line + $this->trace_line_offset) . ' "' .
+            trim(preg_replace('![\t\r\n]+!', ' ', $match[ $line - 1 ])) . '" ';
         if (isset($args)) {
             // individual error message
             $error_text .= $args;
         } else {
+            $expect = array();
             // expected token from parser
-            $error_text .= ' - Unexpected "' . $this->lex->value . '"';
+            $error_text .= ' - Unexpected "' . $lex->value . '"';
             if (count($this->parser->yy_get_expected_tokens($this->parser->yymajor)) <= 4) {
                 foreach ($this->parser->yy_get_expected_tokens($this->parser->yymajor) as $token) {
-                    $exp_token = $this->parser->yyTokenName[$token];
+                    $exp_token = $this->parser->yyTokenName[ $token ];
-                    if (isset($this->lex->smarty_token_names[$exp_token])) {
+                    if (isset($lex->smarty_token_names[ $exp_token ])) {
                         // token type from lexer
-                        $expect[] = '"' . $this->lex->smarty_token_names[$exp_token] . '"';
+                        $expect[] = '"' . $lex->smarty_token_names[ $exp_token ] . '"';
                     } else {
                         // otherwise internal token name
-                        $expect[] = $this->parser->yyTokenName[$token];
+                        $expect[] = $this->parser->yyTokenName[ $token ];
                     }
                 }
                 $error_text .= ', expected one of: ' . implode(' , ', $expect);
@@ -815,7 +1162,7 @@
         }
         $e = new SmartyCompilerException($error_text);
         $e->line = $line;
-        $e->source = trim(preg_replace('![\t\r\n]+!', ' ', $match[$line - 1]));
+        $e->source = trim(preg_replace('![\t\r\n]+!', ' ', $match[ $line - 1 ]));
         $e->desc = $args;
         $e->template = $this->template->source->filepath;
         throw $e;
